/*
   piktd.h -- PIKT common header file for pikt & piktd

   $Header: /var/cvs/PIKT/pikt/src/piktd/piktd.h,v 1.62 2007/01/18 13:17:31 berto Exp $

   This file is part of PIKT ("Problem Informant/Killer Tool").
   Copyright (C) 1998-2007 by Robert Osterlund.

   PIKT is a trademark of the University of Chicago.  All Rights Reserved.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   PIKT is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
   USA.

   Send problem reports, bouquets and brickbats to:  pikt-bugs@pikt.org
 */

#define MAXVAP		64	/* MAXVAP, the maximum level of array
				   nesting, is an arbitrarily large
				   figure for its context
				 */
#define MAXFNN		64	/* MAXFNN, the maximum level of function
				   nesting, is an arbitrarily large
				   figure for its context
				 */

#define MAXVALSCN	65536	/* max number of regexp & valscn matches */

#define MAXARYDIM	3	/* max number of array dimensions */

#define MAXARNDX	2147483647	/* max array index, 32-bit signed long
					 */
#define ERRARNDX	((signed long) ERROR)	/* array index error value */
#define NILARNDX	((signed long) NIL)	/* array index null value */

#define MAXDBLSTR	320	/* max length of double string */
#define MAXFLTSTR	48	/* max length of float string */
#define MAXINTSTR	16	/* max length of int string */

#define MINCHKSUM	-3	/* lowest  $checksum() level now supported */
#define MAXCHKSUM	5	/* highest $checksum() level now supported */

#define EXECWAITWAIT	1	/* arbitarily long pause (in seconds)
				   between checks for existence of exec
				   lock file when doing an exec wait
				 */

#define VLSTR		0	/* string values */
#define VLNOW		-1	/* $ and # values */
#define VLHST		-2	/* % history values */
#define VLPRC		-3	/* @ preceding values */
#define VLPRS		-4	/* regexp and #split() values */
#define INLINNOW	-5	/* $inlin */
#define INLINPRC	-6	/* @inlin */
#define OUTLINNOW	-7	/* $outlin */
#define OUTLINPRC	-8	/* @outlin */
#define RDLINNOW	-9	/* $rdlin */
#define RDLINPRC	-10	/* @rdlin */

/* status */
/* #define NONE         -2 */
/* #define ERROR        -1 */
#define INACTIVE	0
#define ACTIVE		1
#define SUSPENDED	2
#define TESTING		3
#define DEBUGGING	4

/* input type */
#define NOINPUT		0
#define LOGINPUT	1	/* must be 1; ands/ors with val types below */
#define FILEINPUT	2
#define PROCINPUT	3

/* val type */
#define FIXEDVAL	2	/* var referenced in init dat statement */
#define FREEVAL		4	/* var referenced in rule section */
#define BEGINVAL	8	/* var referenced in begin section */
#define ENDVAL		16	/* var referenced in end section */

/* expr type */
#define RHS		0	/* right-hand side */
#define	LHS		1	/* left-hand side */

/* rul type */
#define BEG		1
#define RUL		2
#define END		3

/* used in scan functions */
#define BEGINDAT	1
#define INDAT		2
#define ENDDAT		3
#define OUTDAT		4

/* pos type */
#define FIELDS		1
#define COLUMNS		2
#define REGEXPR		3

/* filestat type */
#define EXIST		0
#define ZEROLEN		1
#define REGFILE		2
#define DIRECTORY	3
#define CHARSPEC	4
#define BLKSPEC		5
#define PIPE		6
#define SYMLINK		7
#define SOCKET		8

/* trim type */
#define NEITHER		0
#define LEFT		1
#define RIGHT		2
#define BOTH		3

/* sys type */
#define SYSTEM		0
#define COMMAND		1

/* var type */
#define SCALAR		0
#define ARRAY		1

/* direction type */
#define FORWARD		0
#define BACKWARD	~0

#define KEYBEGIN	'\['
#define KEYEND		']'
#define KEYSEP		":"

/* some extremely useful macros follow, without which the code would be
   much harder to read

   my entries in the obfuscated code contest:
 */

#define ALMNAM			alarmcurr->name
#define STATUS			alarmcurr->status
#define LEVEL			alarmcurr->level
#define TASK			alarmcurr->task
#define INPUTTYP		alarmcurr->input.type
#define INPUTSRC		alarmcurr->input.source
#define INPUTTMPFIL		alarmcurr->input.tmpfil
#define INPUTBAKFIL		alarmcurr->input.bakfil
#define INPUTLOGNAME		alarmcurr->input.logname
#define INPUTLOGINO		alarmcurr->input.logino
#define INPUTLOGSIZE		alarmcurr->input.logsize
#define INPUTLOGPOSEND		alarmcurr->input.logposend
#define FILTER			alarmcurr->filter
#define SEPARATORS		alarmcurr->separators
#define DATCNT			alarmcurr->data.datcnt
#define MAXDATNDX		alarmcurr->data.maxdatndx
#define POSTYP			alarmcurr->data.postype
#define REGEXP			alarmcurr->data.regexp
#define KEYS			alarmcurr->keys
#define BEGINSECTION		alarmcurr->begin
#define RULESSECTION		alarmcurr->rules
#define ENDSECTION		alarmcurr->end
#define VARS			alarmcurr->vars
#define VRNDXHI			alarmcurr->vrndxhi
#define SCVARS			alarmcurr->scvars
#define VALHST			alarmcurr->valhst
#define HSTTYP			alarmcurr->hsttyp
#define HSTERR			alarmcurr->hsterr
#define REWRITEINFIL		alarmcurr->rewriteinfil

#define VARNAM(ndx)		(alarmcurr->vars[ndx])->name
#define VALTYP(ndx)		(alarmcurr->vars[ndx])->valtype
#define DATTYP(ndx)		(alarmcurr->vars[ndx])->dattype
#define ARYTYP(ndx)		(alarmcurr->vars[ndx])->arytype
#define ARYDIM(ndx)		(alarmcurr->vars[ndx])->arydim
#define OLDHST(ndx)		(alarmcurr->vars[ndx])->oldhst
#define NEWHST(ndx)		(alarmcurr->vars[ndx])->newhst
#define DATSPC(ndx)		(alarmcurr->vars[ndx])->datspc
#define DIRECTION(ndx)		(alarmcurr->vars[ndx])->direction
#define ARKEYS(ndx)		(alarmcurr->vars[ndx])->arkeys
#define SARKEYS(ndx)		(alarmcurr->vars[ndx])->sarkeys
#define RARKEYS(ndx)		(alarmcurr->vars[ndx])->rarkeys
#define LISTINDEX(ndx)		(alarmcurr->vars[ndx])->listindex
#define KEYSFN(ndx)		(alarmcurr->vars[ndx])->keysfn
#define SORTKEYSFN(ndx)		(alarmcurr->vars[ndx])->sortkeysfn
#define MAPKEYSCNT(ndx)		(alarmcurr->vars[ndx])->mapkeyscnt
#define MAPKEYSVRNDXARY(ndx)	(alarmcurr->vars[ndx])->mapkeysvrndxary

#define ALTNAM			altcurr

/* reference the fldnum */
#define FLDNUM(vndx,andx,akey)		lookupspc(vndx,andx,akey)->fldnum

/* reference the begincol */
#define BEGINCOL(vndx,andx,akey)	lookupspc(vndx,andx,akey)->begincol

/* reference the endcol */
#define ENDCOL(vndx,andx,akey)		lookupspc(vndx,andx,akey)->endcol

/* reference whether trim */
#define TRIM(vndx,andx,akey)		lookupspc(vndx,andx,akey)->trim

/* for queued messages to be e-mailed or printed */
typedef struct _msgq {
	char *line;
	struct _msgq *next;
} msgq;

/* for storing alarm script tokens */
typedef struct _tok {
	signed char *token;
	struct _tok *next;
} tok;

/* for recording statement info */
typedef struct _stm {
	int type;		/* DO, IF, ELIF, ... */
	int status;		/* NONE/ERROR/ACTIVE/INACTIVE */
	tok *rhsexpr;		/* expr on right side of = in set statement */
	signed int vrndx;	/* index of var on left side of set
				   statement
				 */
	tok *lhsexpr;		/* array index expr on left side of set
				   statement
				 */
	signed long arndx[MAXARYDIM+1];	/* array indices on left
					   side of set statement
					*/
	char *arkey;		/* array key on left side of set statement */
	char *logfile;		/* logfile tied to output log statement */
	struct _stm *tnext;	/* next statement if current statement
				   is true
				 */
	struct _stm *fnext;	/* next statement if current statement
				   is false
				 */
	struct _stm *aux;	/* auxiliary/dummy statement */
	struct _stm *next;	/* next linked statement, defaults to tnext */
} stm;

/* for recording input info */
typedef struct {
	int type;
	char *source;			/* input-generating command string */
	char *tmpfil;			/* input file tmp file when rewriting */
	char *bakfil;			/* input file backup when rewriting */
	char *logname;			/* input log's name */
	unsigned long logino;		/* input log's inode */
	unsigned long logsize;		/* input log's size in bytes */
	unsigned long logposend;	/* position of last read byte in
					   input log
					 */
} inp;

/* for recording dat info */
typedef struct {
	int datcnt;			/* count of dat items */
	int maxdatndx;			/* highest dat index */
	int postype;			/* FIELDS/COLUMNS/REGEXPR */
	char *regexp;			/* regexp, if dat "<regexp>" */
} dat;

/* for history value lookup keys */
typedef struct _ky {
	signed int vrndx;		/* var index */
	signed long arndx[MAXARYDIM+1];	/* array indices */
	char *arkey;			/* array key */
	struct _ky *prev;
	struct _ky *next;
} ky;

/* list of rules */
typedef struct _rul {
	signed int rulnum;		/* rule number */
	stm *statements;
	struct _rul *next;
} rul;

/* for stat functions */
typedef struct _st {
	double num;		/* a value */
	int freq;		/* its frequency of occurence */
	struct _st *next;
} st;

/* value */
typedef struct _vl {
	signed long ndx[MAXARYDIM+1];
	char *key;
	double num;
	char *str;
	FILE *fil;
	struct _vl *prev;
	struct _vl *next;
} vl;

/* context val */
typedef struct _val {
	vl* vals[MAXVARS+1][10];
	int nodes[MAXVARS+1][10];
	int direction[MAXVARS+1];
} val;

/* dat specs */
typedef struct _spc {
	signed long ndx[MAXARYDIM+1];
	char *key;
	int fldnum;		/* the field number */
	int begincol;		/* its begin column, if columnar */
	int endcol;		/* its end column, if columnar */
	int trim;		/* trim leading/trailing whitespace? */
	struct _spc *prev;
	struct _spc *next;
} spc;

/*   */
typedef struct {
	char *name;		/* var name */
	int valtype;		/* FIXEDVAL/FREEVAL/BEGINVAL/ENDVAL */
	int dattype;		/* STRING/NUMBER/FILEHANDLE/PROCHANDLE */
	int arytype;		/* STRING/NUMBER */
	int arydim;		/* array dimensions */
	int oldhst;		/* found in old history file */
	int newhst;		/* record in new history file */
	spc* datspc[10];
	int nodes[10];
	int direction;		/* FORWARD/BACKWARD */
	ky *arkeys;
	ky *sarkeys;
	ky *rarkeys;
	int listindex;
	int keysfn;
	int sortkeysfn;
	int mapkeyscnt;
	int mapkeysvrndxary;
} var;

/* alarm info */
typedef struct _alrm {
	char *name;			/* alarm name */
	int status;			/* NONE/ERROR/ACTIVE/INACTIVE/SUSPENDED/TESTING/DEBUGGING */
	int level;			/* EMERG/ALERT/CRIT/... */
	char *task;			/* alarm description */
	inp input;			/* input info */
	char *filter;			/* input filter, if any */
	char *separators;		/* dat field separators, if any */
	dat data;			/* dat info */
	ky *keys;			/* history lookup keys */
	rul *begin;			/* begin rule (one only) */
	rul *rules;			/* list of rules */
	rul *end;			/* end rule (one only) */
	var *vars[MAXVARS+1];
	int vrndxhi;			/* the highest var index attained */
	ky *scvars;			/* scancolumn vars list */
	val *valhst;
	int hsttyp;			/* FIXEDVAL|FREEVAL|BEGINVAL|ENDVAL */			
	int hsterr;			/* error in history processing */
	int rewriteinfil;		/* rewrite the input file? */
	struct _alrm *next;
} alrm;

/* alert info */
typedef struct _alt {
	char *name;		/* name of the alert */
	float minprob;		/* 0.01-1.00, i.e., 1-100% */
	float hrprob;		/* 0.01-1.00, i.e., 1-100% */
	float domprob;		/* 0.01-1.00, i.e., 1-100% */
	float monprob;		/* 0.01-1.00, i.e., 1-100% */
	float dowprob;		/* 0.01-1.00, i.e., 1-100% */
	unsigned long himin;	/* 32-59 */
	unsigned long lomin;	/*  0-31 */
	unsigned long hr;	/*  0-23 */
	unsigned long dom;	/*  1-31 */
	unsigned long mon;	/*  1-12 */
	unsigned long dow;	/*  0- 6 */
	unsigned int drift;	/* how much, in minutes, the alert launch is
				   allowed to randomly drift from the
				   center timing
				 */
	unsigned int timer;	/* for drifting alerts, how many minutes
				   until the next alert launch
				 */
	char *piktcmd;		/* the command to execute the alert */
	char *lockfile;		/* the alert's lock file */
	struct _alt *next;
} alt;

extern const char pikt_version[];
extern const char piktd_version[];

extern int isscript;			/* is this an individual script? */
extern int isalert;			/* is this one or more scripts
					   grouped as an alert?
					 */

extern int interactive;

extern unsigned stroffset; 		/* offset from beginning of current
					   string
					 */

extern char *altcurr;			/* current alert name */

extern char *command;			/* 'pikt +C' quoted command string */
extern char *ccp;

extern char *altlockfile;		/* name of lock file for this alert */
extern char *execlockfile;		/* name of exec lock file for this alert */
extern char *piktlog;			/* name of piktlog for this alert */
/* extern char syslog[]; */		/* path of syslog file */

extern ino_t inputino;
extern off_t inputsize;
extern unsigned long inputposend;
extern pid_t inputpid;

extern char inlin[2][MAXLINE+1];	/* input lines */
extern char *inlinnow, *inlinprc;	/* ptrs to current/preceding inlin */
extern int innum;			/* number of current input line */
extern int inlen;			/* length of current input line */
extern char *outlinnow, *outlinprc;	/* ptrs to current/preceding output
					   line (replacement for current input
					   line when rewriting input file)
					 */
extern char rdlin[2][MAXLINE+1];	/* output lines from #read() */
extern char *rdlinnow, *rdlinprc;	/* ptrs to current/preceding rdlin */
extern int skip;			/* number of input lines to skip */
extern int eoi;				/* is end-of-input? */

extern int numcnt;			/* count of stats; used by stat fns */
extern double numsum;			/* sum of stats; used by stat fns */
extern double nummax;			/* max of stats; used by stat fns */
extern double nummin;			/* min of stats; used by stat fns */
extern st *stats;			/* list of stats; used by stat fns */

/* for timing */
extern char *tcp;
extern float tp;
extern unsigned long cb;
extern int clo, chi, cmin, cmax;	/* timing bit parameters */
extern int mop;				/* mins in one period */
extern int map;				/* mins in all periods */
extern int ttp;				/* total time periods */
extern int etp;				/* earliest time period */
extern int ptp;				/* previous time period */
extern int mai;				/* minimum alert interval (in mins) */

extern int dohistory;		/* do history processing? */

extern int **p2cfd, **c2pfd;	/* ipc parent-to-child and
				   child-to-parent channels;
				   for coordinating within
				   scanopen()
				 */

extern int exprtyp;		/* LHS/RHS */

extern int doeval;		/* evaluate this expression? */
extern int exprres;		/* TRUE/FALSE/ERROR */
extern double exprval;		/* eval'ed expression as a number */
extern char *exprstr;		/* eval'ed expression as a string */

extern int dpls;		/* decimal places */

extern int doregvar;		/* are we processing the #split(), #parse(),
				   #members(), or #keys() functions? if so,
				   we need to set this to force a special
				   regvar() call
				 */

extern int vrndxfirst;		/* note the var index when doing a #split()
				   or #members()
				 */
extern int vrndxcurr;		/* ditto */

extern signed long arndx[MAXARYDIM+1];		/* current arndx[] */
extern signed long arndxnil[MAXARYDIM+1];	/* arndx[] all nil vals */
extern signed long arndxnul[MAXARYDIM+1];	/* arndx[] all nul vals */

extern regmatch_t regmatch[MAXVALSCN+1];	/* matched ()'ed expressions */
extern int matches;				/* number of matched ()'ed
						   expressions
						 */

extern const char *arytyp[];	/* ARYSTR/ARYNUM */

extern char fnnumnames[];	/* string of all number function names */
extern char fnstrnames[];	/* string of all string function names */

extern int iserrdef;			/* is #error() or #defined()
					   function?
					 */
extern int islistfn;			/* is #split(), #parse(), #members(),
					   or #keys() function?
					 */

extern char *mailcmd, *lpcmd;		/* mail/print commands */

extern msgq *mailhdrmsg, *printhdrmsg;		/* queued mail/print headers */
extern msgq *mailalmmsg[], *printalmmsg[];	/* queued mail/print
						   alarm messages
						 */
extern msgq *mailhdrmsgcurr, *printhdrmsgcurr;
extern msgq *mailalmmsgcurr[], *printalmmsgcurr[];

extern FILE *altin;			/* script (*.alt or *.pkt) input */
extern FILE *hstin;			/* history (*.hst) input */
extern FILE *hstout;			/* history (*.tmp) output */
extern char *hsttmpfile;		/* temp (new) history file */

extern alrm *alarms;			/* list of alarms */

extern int newmailalarm, newmailalert, newprintalarm, newprintalert;

extern alrm *alarmcurr;		/* current alarm */
extern val *valcurr;		/* current val */
extern ky *scvarcurr;		/* current scancolumn var */
extern ky *keycurr;		/* current key */
extern rul *rulcurr;		/* current rule */
extern tok *tokcurr;		/* current token */
extern stm *stmcurr;		/* current statement */

extern val *valp[MAXVAP];	/* array of val pointers */
extern val *valnow;		/* val in current time context */
extern val *valprc;		/* val for preceding input line */

extern int vapndx;		/* level of array nesting */

extern int isfakearray;		/* are we faking an array on the left side
				   of the current set statement?
				 */

extern signed char *valscn[MAXVALSCN+1];	/* scanned values */

extern char *keystr;		/* history lookup key string for current
				   input line
				 */
extern int keystrlen;		/* length of the current keystr */

extern int keyseplen;		/* length of KEYSEP */

/* command-line functions */
extern void pikt_usage(void);
extern void piktd_usage(void);

/* lexer and parser functions */
extern int cmdparse(void);
extern int altparse(void);
extern int exprparse(void);
extern int hstparse(void);
extern int timingparse(void);
extern int cmdlex(void);
extern int altlex(void);
extern int exprlex(void);
extern int hstlex(void);
extern int timinglex(void);
extern void cmderror(const char *);
extern void alterror(const char *);
extern void exprerror(const char *);
extern void hsterror(const char *);
extern void timingerror(const char *);

/* alt file functions */
extern void regalm(char *);
extern void initvals(val **);
extern int regvar(char *, int, int, int, int, signed long *, char *, char *);
extern void regscvar(int, signed long *, char *);
extern void regkey(char *, int, signed long *, char *);
extern void regrul(int);
extern void regtok(signed char *, int);
extern void duptok(tok *, tok **);
extern void regstm(int);
extern void reghst(int);
extern signed int varndx(char *);
extern int vardattype(char *, int, int);

/* array functions */
extern spc *lookupspc(int, signed long *, char *);
extern vl *lookupvl(val *, int, signed long *, char *, int);
extern vl *findvl(val *, int, signed long *, char *);
extern spc *regspc(int, signed long *, char *);
extern vl *regvl(val *, int, signed long *, char *, int);
extern int delvl(val *, int, signed long *, char *, int);
extern ky *regarkey(int, ky **, signed long *, char *, int);
extern int delarkey(int, ky **, char *, int);
extern ky *lookuparkey(int, ky *, char *);
extern int mapmembers(int, char *, int);
extern int mapkeys(int, ky *, int, int);

/* expr functions */
extern time_t now(void);
extern time_t today(void);
extern time_t datevalue(int, int, int);
extern time_t timevalue(int, int, int);
extern int second(time_t);
extern int minute(time_t);
extern int hour(time_t);
extern int day(time_t);
extern int month(time_t);
extern int year(time_t);
extern int weekday(time_t);
extern int yearday(time_t);
extern int yearweek(time_t);
extern char *ampm(time_t);
extern int monthnumber(char *);
extern const char *monthname(int);
extern int daynumber(char *);
extern const char *dayname(int);
extern int daysbetween(time_t, time_t);
extern int age(char *, char *, char *);
extern int filestat(char *, int);

extern int ceiling(double);
extern int integer(double);
extern int my_round(double);
extern int my_trunc(double);
extern int isint(double);
extern void regstat(double);
extern void freestats(void);
extern double median(void);
extern double mode(void);

extern double myrandom(int);

extern char *filemode(const char *);
extern int fileino(const char *);
extern int filelinks(const char *);
extern int fileuid(const char *);
extern int filegid(const char *);
extern long filesize(const char *);
extern time_t fileatime(const char *);
extern time_t filemtime(const char *);
extern time_t filectime(const char *);

extern char *pwname(int, const signed char *);
extern char *pwpasswd(int, const signed char *);
extern int pwuid(int, const signed char *);
extern int pwgid(int, const signed char *);
extern char *pwgecos(int, const signed char *);
extern char *pwdir(int, const signed char *);
extern char *pwshell(int, const signed char *);

extern char *grname(int, const signed char *);
extern char *grpasswd(int, const signed char *);
extern int grgid(int, const signed char *);
extern char *grmem(int, const signed char *);

extern char *my_char(int);
extern char *chop(char *, int);
extern int code(char *);
extern char *fixed(double, int);
extern int search(char *, char *, int);
extern int rsearch(char *, char *);
extern char *reverse(char *);
extern char *lower(char *);
extern char *proper(char *);
extern char *repeat(char *, int);
extern char *replace(char *, char *, int, int);
extern char *substitute(char *, char *, char *, int);
extern char *substring(char *, int, size_t);
extern char *sys(signed char *, int);
extern signed char *trim(char *, int);
extern char *upper(char *);

extern char *my_basename(char *);
extern char *my_dirname(char *);

/* history functions */
extern alrm *lookupalarm(char *);
extern void verifylog(char *);
extern void verifykey(int, signed long *, char *);
extern void verifyvar(int, char *);
/* extern void verifyfld(int, signed long *, char *, int); */
extern void verifydim(int, int);
extern void verifytyp(int, int);
extern void verifyval(int, signed long *, char *);
extern void openhistory(char *);
extern void closehistory(char *);
extern int beginhistory(void);
extern int endhistory(void);
extern int makekeystr(void);
extern void freevals(val **, int);
extern int recordvalnows(void);

/* timing functions */
extern void parsetiming(char *, float *, unsigned long *,
                        int, int, int, int, int, int, int);
extern unsigned int randomizetimer(unsigned int);
extern void settimebits(struct tm *, unsigned long *, unsigned long *,
                                     unsigned long *, unsigned long *,
                                     unsigned long *, unsigned long *);
extern int timematch(alt *, unsigned long, unsigned long,
                            unsigned long, unsigned long,
                            unsigned long, unsigned long);

/* statement functions */
extern int dostatement(int);

/* message functions */
extern void altheader(msgq **, msgq**, int);
extern void almheader(msgq **, msgq**, int);
extern void almline(msgq **, msgq**, char *, int);
extern void freemsg(msgq **);

/* input functions */
extern int openinput(FILE **, pid_t *, int, char *, FILE **, char *);
extern int closeinput(FILE *, pid_t, FILE *);
extern FILE *inputopen(char *, pid_t *);
extern void inputclose(FILE *, pid_t);

/* script functions */
extern int dobegin(void);
extern int doend(void);
extern int dorules(int, FILE *, int, FILE *);
extern int advanceinput(void);

/* scan functions */
extern int scaninput(int);
extern int scanfields(int, char *, char *, int);
extern int scancolumns(char *);
extern void freevalscn(void);

/* regexp functions */
extern int regexp(int, char *, char *, int, int);

/* debugging functions */
extern void dumpvals(val *);
extern void dumpsps(stm *, char *);
extern void dumptime(char *, unsigned long);
/* extern void dumpalarms(void); */
